//!
//! @file mc_drv.c,v
//!
//! Copyright (c) 2008 Atmel.
//!
//! @brief d@ײ :\n
//!		- d@䏉\n
//!		- PWMXV\n
//!		- PWMˏo͐؂ւ\n
//!		- 荞\n
//!
//! @version 1.19
//!

//_____ ݸٰ _______________________________________________________________

#include "config.h"

#include "mc_drv.h"
#include "mc_interface.h"
#include "mc_control.h"

#include "adc\adc_drv.h"
#include "dac\Dac_drv.h"
#include "pll\pll_drv.h"
#include "comparator\comparator_drv.h"

#include "stdio.h"

U8 count = 1;						// countϐn̎ł̕ϑxvZɎgp܂B
U16 average = 0;
U8 ovf_timer = 0;					// ovf_timerϐ8ޯČv16ޯČvЭڰĂ̂Ɏgp܂B

Bool inrush_mask_flag = FALSE;
U16 inrush_delay = 0;

Bool g_mc_read_enable = FALSE;		// xǂݍ݉׸
Bool g_tick = FALSE;				//!< ̎l̐Ɏgp

Bool current_EOC = FALSE;			// ϊI׸

char State = CONV_INIT;				// A/Dϊv敔̏
char ADC_State = FREE;				// BUSY=sAFREE=񑖍s(~)
extern U8 PWMxB;

/******************************************************************************/
/******************************************************************************/
/*		ʰ޳														  */
/******************************************************************************/
/******************************************************************************/

/**
* @brief	ʰ޳
* @pre		Ȃ
* @post		ʰ޳̏
*/
void mc_init_HW(void)
{
  // o݌`Ԑݒ
  // PD0H_A, PB7L_A
  // PC0H_B, PB6L_B
  // PB0H_C, PB1L_C

  // PSCOUT`Ԑݒ(ύXs)
  // ߰B:
  DDRB = (1<<DDB7)|(1<<DDB6)|(1<<DDB1)|(1<<DDB0);
  // ߰C:
  DDRC = (1<<DDC0);
  // ߰D:
  DDRD = (1<<DDD0);

  // DDnx = 0:́A1:o (n=B,C,D,EAx=0,1,2,3,4,5,6,7)
  // PB3EXT1						PB4EXT2
  // PC1EXT3						PC2EXT4
  // PB5EXT5/POT					PE1EXT6
  // PD3EXT7/MOSI/LIN_TxD/TxD		PD4EXT8/MISO/LIN_RxD/RxD
  // PE0EXT9/NRES					PD2EXT10/MISO

  // ʰ޳ɏ]DDnxύX
  // ߰B:
  DDRB |= (0<<DDB5)|(1<<DDB4)|(0<<DDB3);
  // ߰C:
  DDRC |= (0<<DDC2)|(0<<DDC1);
  // ߰D:
  DDRD |= (0<<DDD4)|(0<<DDD3)|(0<<DDD2);	// UART̪܂JTAGICEmkUgpꍇɒ
  // ߰E:
  DDRE |= (1<<DDE2)|(0<<DDE1)|(0<<DDE0);	// PE0JTAGICEmkUɂĒ

  // MOS-FET쓮pxLowo
  PORTB &= ~(1<<PORTB7 | 1<<PORTB6 | 1<<PORTB1 | 1<<PORTB0);
  PORTC &= ~(1<<PORTC0);
  PORTD &= ~(1<<PORTD0);

  // ٱߊ
  PORTB |= (1<<PORTB3);						/* EXT1͐ɂĎgp܂B*/
  PORTC |= (1<<PORTC1);						/* EXT3͐ɂĎgp܂B*/
  PORTD |= (1<<PORTD1);

  // 1p޼ٓ͋֎~
  // rp޼ٓ͂͋֎~܂B
  DIDR0 = (0<<ADC6D)|(0<<ADC3D)|(0<<ADC2D);
  DIDR1 = (0<<ACMP0D)|(0<<ACMP1D)|(1<<AMP1PD)|(1<<AMP1ND);

  // AT90PWM3Oݏ
  EICRA =(0<<ISC21)|(1<<ISC20)|(0<<ISC11)|(1<<ISC10)|(0<<ISC01)|(1<<ISC00);
  EIFR = (1<<INTF2)|(1<<INTF1)|(1<<INTF0);	// `Ԑݒ̂߂ɉ\Ȋ荞݂
  EIMSK=(1<<INT2)|(1<<INT1)|(1<<INT0);

  // : PWM̑OD/AϊƉߓd
  init_dac();
  mc_set_Over_Current(IMAX);

  /* PWM */
  Start_pll_32_mega();
  Wait_pll_ready();

  // 񓮍:
  // PSCx_Init(Period_Half, Dutyx0_Half, Synchro, Dutyx1_Half)
  PSC0_Init(255,0,1,0);
  PSC1_Init(255,0,1,0);
  PSC2_Init(255,0,1,0);

  mc_init_timer0();
  mc_init_timer1();

  init_comparator0();
  init_comparator1();
  init_comparator2();
}

/**
* @brief	1
* @pre		Ȃ
* @post		ʰ޳
*/
void init_amplifier_1(void)
{
  AMP1CSR =  (1<<AMP1EN)					/* 틖 */ \
			|(1<<AMP1G1)|(0<<AMP1G0)		/* =20{ */ \
			|(0<<AMP1TS1)|(1<<AMP1TS0)		/* PSC0̸ۯ */ ;
}

// PSC`ԂɉPSC
//  0- 1XΓ
//  1- 2XΓ
//  2- 4XΓ
//  3- 񓮍

/**
* @brief	PSC0PWM평
*/
void PSC0_Init ( unsigned int OCRnRB,
				 unsigned int OCRnSB,
				 unsigned int OCRnRA,
				 unsigned int OCRnSA)
{
  OCR0SAH = HIGH(OCRnSA);
  OCR0SAL = LOW(OCRnSA);
  OCR0RAH = HIGH(OCRnRA);
  OCR0RAL = LOW(OCRnRA);
  OCR0SBH = HIGH(OCRnSB);
  OCR0SBL = LOW(OCRnSB);
  OCR0RBH = HIGH(OCRnRB);
  OCR0RBL = LOW(OCRnRB);

  PCNF0 =  RAMP_MODE_NUMBER | (1<<PCLKSEL0) | OUTPUT_ACTIVE_HIGH ;
  PFRC0A = (1<<PELEV0A)|(1<<PFLTE0A)|(0<<PRFM0A3)|(1<<PRFM0A2)|(1<<PRFM0A1)|(1<<PRFM0A0);
  PFRC0B = 0;
  PSOC0 = (1<<PSYNC00);							// (PSC̏㏸v)OCRnSAƂ̈vŐMo
  PCTL0 = (0<<PAOC0A)|(1<<PARUN0)|PRESC_NODIV;	/* AUTORUN !! */
}

/**
* @brief	PSC1PWM평
*/
void PSC1_Init ( unsigned int OCRnRB,
				 unsigned int OCRnSB,
				 unsigned int OCRnRA,
				 unsigned int OCRnSA)
{
  OCR1SAH = HIGH(OCRnSA);
  OCR1SAL = LOW(OCRnSA);
  OCR1RAH = HIGH(OCRnRA);
  OCR1RAL = LOW(OCRnRA);
  OCR1SBH = HIGH(OCRnSB);
  OCR1SBL = LOW(OCRnSB);
  OCR1RBH = HIGH(OCRnRB);
  OCR1RBL = LOW(OCRnRB);

  PCNF1 =  RAMP_MODE_NUMBER | (1<<PCLKSEL1) | OUTPUT_ACTIVE_HIGH ;
  PFRC1A = 0;
  PFRC1B = 0;
  PCTL1 = (0<<PAOC1A)|(1<<PARUN1)|PRESC_NODIV;	/* AUTORUN !! */
}


/**
* @brief	PSC2PWM평
*/
void PSC2_Init ( unsigned int OCRnRB,
				 unsigned int OCRnSB,
				 unsigned int OCRnRA,
				 unsigned int OCRnSA)
{
  OCR2SAH = HIGH(OCRnSA);
  OCR2SAL = LOW(OCRnSA);
  OCR2RAH = HIGH(OCRnRA);
  OCR2RAL = LOW(OCRnRA);
  OCR2SBH = HIGH(OCRnSB);
  OCR2SBL = LOW(OCRnSB);
  OCR2RBH = HIGH(OCRnRB);
  OCR2RBL = LOW(OCRnRB);

  PCNF2 =  RAMP_MODE_NUMBER | (1<<PCLKSEL2) | OUTPUT_ACTIVE_HIGH ;
  PFRC2A = 0;
  PFRC2B = 0;
  PCTL2 = (0<<PAOC2A)|(1<<PRUN2)|PRESC_NODIV;	/* RUN !! */
}

/***************************************************************************/
/***************************************************************************/
/*		d@̑(])pS֐									   */
/***************************************************************************/
/***************************************************************************/

/**
* @brief	ΰيm̒l(1`6)擾
* @param	unsigned char(ΰيm̒l)Ԃ܂B
* @pre		߰PBPĎ`Ԑݒ
* @post		ʒu̐Vl
*/
U8 mc_get_hall(void)
{
  return HALL_SENSOR_VALUE();
}

/**
 * @brief	O (ΰيmAAݐ؂ւ`)
 * @pre		Ǒ݂`Ԑݒ()
 * @post	ΰٕϐɐVl
 */
#ifdef __GNUC__
ISR(ANALOG_COMP_0_vect)
#else
#pragma vector = HALL_A()
__interrupt void mc_hall_a(void)
#endif
{
  mc_switch_commutation(HALL_SENSOR_VALUE());
  // ΰيmA̗オ[ł̐葬x
  if (PIND&(1<<PORTD7))
  {
	mc_estimation_speed();
	g_mc_read_enable=FALSE;		// ǂݍ1ҋ@ݒ
  }
  else
  {
	g_mc_read_enable=TRUE;
  }
}

/**
 * @brief	O (ΰيmBAݐ؂ւ`)
 * @pre		Ǒ݂`Ԑݒ()
 * @post	ΰٕϐɐVl
 */
#ifdef __GNUC__
ISR(ANALOG_COMP_1_vect)
#else
#pragma vector = HALL_B()
__interrupt void mc_hall_b(void)
#endif
{
  mc_switch_commutation(HALL_SENSOR_VALUE());
}

 /**
 * @brief	O (ΰيmCAݐ؂ւ`)
 * @pre		Ǒ݂`Ԑݒ()
 * @post	ΰٕϐɐVl
 */
#ifdef __GNUC__
ISR(ANALOG_COMP_2_vect)
#else
#pragma vector = HALL_C()
__interrupt void mc_hall_c(void)
#endif
{
  mc_switch_commutation(HALL_SENSOR_VALUE());
}

/**
* @brief	JԂɂČvZꂽlɏ]PSCޭè ْlݒ
*/
void mc_duty_cycle(U8 level)
{
  U8 duty;
  duty = level;

  PCNF0 = SET_PLOCK | RAMP_MODE_NUMBER |(1<<PCLKSEL0)|(1<<POP0);	/* PSC0Œ艻(ύXۗ) */
  PCNF1 = SET_PLOCK | RAMP_MODE_NUMBER |(1<<PCLKSEL1)|(1<<POP1);	/* PSC1Œ艻(ύXۗ) */
  PCNF2 = SET_PLOCK | RAMP_MODE_NUMBER |(1<<PCLKSEL2)|(1<<POP2);	/* PSC2Œ艻(ύXۗ) */

  // Duty=  0ޭè    0%
  // Duty=255ޭè  100%

  // PSCn0pޭè ِݒ
  OCR0SAH = 0;
  OCR0SAL = duty;

  OCR1SAH = 0;
  OCR1SAL = duty;

  OCR2SAH = 0;
  OCR2SAL = duty;

  // PWM헪ɏ]PSCn1pޭè ِݒ
  #ifdef HIGH_AND_LOW_PWM
  // HL̽PWM
	OCR0SBH = 0;
	OCR0SBL = duty;

	OCR1SBH = 0;
	OCR1SBL = duty;

	OCR2SBH = 0;
	OCR2SBL = duty;
  #else
  // PWMHɂ܂B
  // L100%ޭè (ᑬ)
	if (PWMxB==0x1)		// AT90PWM3BŁA
	{
	  OCR0SBH = 0;
	  OCR0SBL = 0;

	  OCR1SBH = 0;
	  OCR1SBL = 0;

	  OCR2SBH = 0;
	  OCR2SBL = 0;
	}
	else				// AT90PWPM3ŁA
	{
	  OCR0SBH = 0;
	  OCR0SBL = 255;

	  OCR1SBH = 0;
	  OCR1SBL = 255;

	  OCR2SBH = 0;
	  OCR2SBL = 255;
	}
  #endif

  Disable_interrupt();
  PCNF0 = RELEASE_PLOCK | RAMP_MODE_NUMBER |(1<<PCLKSEL0)|(1<<POP0);	/* PSC0Œ艻(ݒ蔽f) */
  PCNF1 = RELEASE_PLOCK | RAMP_MODE_NUMBER |(1<<PCLKSEL1)|(1<<POP1);	/* PSC1Œ艻(ݒ蔽f) */
  PCNF2 = RELEASE_PLOCK | RAMP_MODE_NUMBER |(1<<PCLKSEL2)|(1<<POP2);	/* PSC2Œ艻(ݒ蔽f) */
  Enable_interrupt();
}

/**
* @brief	m܂͐ʒuɏ]ďo͂ɐ؂ւ(])lݒ
*
* @param	ʒu(1`6)ƕ(FORWARD܂BACKWARD)
*/
void mc_switch_commutation(U8 position)
{
  // Ő(])邽߂ɓd@擾
  char direction = mc_get_motor_direction();

  // ͎gp҂d@nAxw肪0ƈقȂꍇɂ(])܂B
  if ((mc_motor_is_running()) && (mc_get_motor_speed()!=0))
  {
	mc_duty_cycle(mc_get_Duty_Cycle());
	switch(position)
	{
	// ]qʒuɏ]
	  case HS_001:	if (direction==CCW)	{Set_Q1Q6();}
					else				{Set_Q5Q2();}
					break;
	  case HS_101:	if (direction==CCW)	{Set_Q3Q6();}
					else				{Set_Q5Q4();}
					break;
	  case HS_100:	if (direction==CCW)	{Set_Q3Q2();}
					else				{Set_Q1Q4();}
					break;
	  case HS_110:	if (direction==CCW)	{Set_Q5Q2();}
					else				{Set_Q1Q6();}
					break;
	  case HS_010:	if (direction==CCW)	{Set_Q5Q4();}
					else				{Set_Q3Q6();}
					break;
	  case HS_011:	if (direction==CCW)	{Set_Q1Q4();}
					else				{Set_Q3Q2();}
					break;
	  default :		break;
	}
  }
  else
  {
	Set_none();		// SOFFɂ܂B
  }
}

/******************************************************************************/
/******************************************************************************/
/*		v1 : g_tick												  */
/******************************************************************************/
/******************************************************************************/

/**
 * @brief	v1`Ԑݒ
 * x̍̎p250sԊuł̊𐶐̂Ɏgp܂B
 * @pre		Ȃ
 * @post	256s̊荞
*/
void mc_init_timer1(void)
{
  TCCR1A = 0;								// W߰ē,CTC
  TCCR1B = 1<<WGM12 | 1<<CS11 | 1<<CS10 ;	// CTC,64Ou(4s)Ŏn
  TCCR1C = 0;
  OCR1AH = 0;								// 256svl(2564-1=63)w
  OCR1AL = 63;
  TIMSK1=(1<<OCIE1A);						// rAv荞݋
}

/**
  * @brief	JԂJn(main.c)
  * @pre	v1ڼ޽̌`Ԑݒ
  * @post	g_tickmain.cŒJԂɎgp܂B
*/
#ifdef __GNUC__
ISR(TIMER1_COMPA_vect)
#else
#pragma vector = TIMER1_COMPA_vect
__interrupt void launch_sampling_period(void)
#endif
{
  g_tick = TRUE;
}

/******************************************************************************/
/******************************************************************************/
/*		v0 : x													  */
/******************************************************************************/
/******************************************************************************/

/**
 * @brief	v0`Ԑݒ
 * v0͈ꔭɊԊuԂ𐶐̂Ɏgp܂B
 * @pre		Ȃ
 * @post	v0
*/
void mc_init_timer0(void)
{
  TCCR0A = 0;
  TCCR0B = (1<<CS02)|(0<<CS01)|(0<<CS00);		// 256Ou(16s)Ŏn
  TIMSK0 = (1<<TOIE0);
}

/**
  * @brief	xpv0
  * @pre	v0̌`Ԑݒ
  * @post	d@x鎞Ɉ𐶐
*/
#ifdef __GNUC__
ISR(TIMER0_OVF_vect)
#else
#pragma vector = TIMER0_OVF_vect
__interrupt void ovfl_timer0(void)
#endif
{
  TCNT0=0x00;
  ovf_timer++;
  // 125msɐ(])Ȃꍇ
  // 125ms=(61<<8)*8s
  if(ovf_timer >= 100)
  {
	ovf_timer = 0;
	mc_set_motor_measured_speed(0);
	// d@ĂĒ~߂^ĂȂȂAd@͎Iɑs
	if(mc_motor_is_running())mci_retry_run();
  }
}

/**
* @brief	x
* @pre		v0̌`Ԑݒ\n config_motor.hAVERAGE_SPEED_MEASURENT̗L`
* @post		xɊւVl
*/
void mc_estimation_speed(void)
{
  U16 timer_value;
  U32 new_measured_speed;

  if (g_mc_read_enable==TRUE)
  {
	// 8ޯĕϐTCNT0l16ޯČv̼ЭڰĂɎgp܂B
	timer_value = (ovf_timer<<8) + TCNT0;

	if (timer_value == 0) {timer_value += 1 ;}				// 0Zx
	new_measured_speed = K_SPEED / timer_value;
	if(new_measured_speed > 255) new_measured_speed = 255;	// ϐOa

	#ifdef AVERAGE_SPEED_MEASURE
	  // G邽߂ɕς8̎Ŏ܂B
	  average += new_measured_speed;
	  if(count >= n_SAMPLE)
	  {
		count = 1;
		mc_set_motor_measured_speed(average >> 3);
		average = 0;
	  }
	  else count++;
	#else
	  // ωȂȂAۂ̑x擾
	  mc_set_motor_measured_speed(new_measured_speed);
	#endif

	// v0ƕϐؾ
	TCNT0=0x00;
	ovf_timer = 0;
	g_mc_read_enable=FALSE;
  }
}

/******************************************************************************/
/******************************************************************************/
/*		A/Dϊ͓dƉϒȒɎgp								  */
/******************************************************************************/
/******************************************************************************/

/**
* @brief	dl𓾂邽߂ɍ̎菇Jn
* @pre		ƊԊuԂ̏
* @post		ϊI׸ސݒ
*/
#ifdef __GNUC__
ISR(ADC_vect)
#else
#pragma vector = ADC_vect
__interrupt void ADC_end_of_conversion(void)
#endif
{
  if(State == CONV_CURRENT) mc_set_potentiometer_value(Adc_get_8_bits_result());
  if(State == CONV_POT) mci_store_measured_current(Adc_get_10_bits_result());
  ADC_State = FREE;
}

/**
* @brief	A/Dϊp̌v敔Jn
* @pre		Ȃ
* @post		ϒRƓd̒ľ(ch6ch12)擾
*/
void mc_ADC_Scheduler(void)
{
  switch(State)
  {
	case CONV_INIT :
	  init_adc();
	  init_amplifier_1();
	  ADC_State = FREE;
	  State = CONV_POT;
	  break;

	case CONV_POT :
	  if(ADC_State == FREE)
	  {
		ADC_State = BUSY;
		State= CONV_CURRENT;
		Left_adjust_adc_result();
		Start_conv_channel(6);
	  }
	  break;

	case CONV_CURRENT :
	  if(ADC_State == FREE)
	  {
		ADC_State = BUSY;
		State = CONV_POT;
		Right_adjust_adc_result();
		if (PWMxB==0x1)				// AT90PWM3BŁA
		{
		  Start_conv_channel(12);
		}
		else							// AT90PWPM3ŁA
		{
		  Start_amplified_conv_channel(12);
		}
	  }
	  break;
  }
}

/******************************************************************************/
/******************************************************************************/
/*		ߓd`Ԑݒ														  */
/******************************************************************************/
/******************************************************************************/

//! @brief	ߓd臒lݒ
//! @pre	D/Aϊ평
//! @post	ߓd臒lݒ肳܂B
void mc_set_Over_Current(U8 Level)
{
  Set_dac_8_bits(Level);
}

//! @brief	̊֐̖ړI͎n̉ߓd(d)o֎~邱ƂłB\n
void mc_disable_during_inrush(void)
{
  inrush_delay = (U16) 1000;
  inrush_mask_flag = TRUE;
  Disable_over_current();
}

//! @brief	̊֐̖ړI͉ߓdo֎~ɎgpxǗ邱ƂłB\n
void mc_inrush_task(void)
{ 
  if (inrush_mask_flag == TRUE)
  {
	if (inrush_delay-- == 0)
	{
	  inrush_mask_flag = FALSE;
	  Enable_over_current();
	}
  }
}
